#include <stdio.h>
#include "firecam.h"

int main(int argc, char** argv)
{
	elem_query_t eq;
	elem_control_t ec;
	int cam_no;
	int mode;
	int elem_no;
	int value;

	if (firecam_open() < 0)
	{
		printf("Couldn't open ports\n");
		return 0;
	}

	if (argc < 4)
	{
		printf("Usage: elemctrl <cam_no> <get/set> <elem_no> [value]\n");
		return 0;
	}

	cam_no = atoi(argv[1]);
	if (!strcmp(argv[2], "set"))
		mode = 1;
	else
		mode = 0;
	elem_no = atoi(argv[3]);

	if (mode == 1)
	{
		if (argc < 5)
		{
			printf ("Need value\n");
			return 0;
		}
		else if (!strcmp(argv[4], "auto"))
		{
			ec.on_off = 1;
			ec.auto_control = 1;
			ec.value = 0;
			ec.value2 = 0;
		}
		else
		{
			value = atoi(argv[4]);
			ec.on_off = 1;
			ec.auto_control = 0;
			ec.value = value;
			ec.value2 = 0;
		}

		if (firecam_set_elem_status(cam_no, elem_no, &ec) < 0)
		{
			printf ("Couldn't set!\n");
			return 0;
		}
	}
	else
	{
		if (firecam_query_element(cam_no, elem_no, &eq) < 0)
		{
			printf ("Couldn't query\n");
			return 0;
		}

		printf ("Presence Query:\n");
		printf ("Available:\t%u\nAuto Control:\t%u\nMan Control:\t%u\nToggle on/off?\t%u\nMin Value:\t%u\nMax Value:\t%u\n", eq.available, eq.auto_control, eq.man_control, eq.on_off, eq.min_value, eq.max_value);

		if (eq.available == 1)
		{
			if (firecam_get_elem_status(cam_no, elem_no, &ec) < 0)
			{
				printf ("Couldn't get status\n");
				return 0;
			}

			printf("\nCurrent status:\n");
			printf("On/Off:\t\t%u\nAuto/Man:\t%u\nValue:\t\t%u\n", ec.on_off, ec.auto_control, ec.value);
		}
	}

	return 0;
}
	
