#ifndef _FIREWIRE_
#define _FIREWIRE_

// This file enumerates values
// standardized by the 1394 specification.

// Extract physical/bus ID's out of a 16-bit Node-ID
#define PHY_ID(x) (x&0x3F)
#define BUS_ID(x) ((x&0xC0)>>6)

#define NODE_BROADCAST 0xFFFF

// 4-bit ACK codes
#define		ACK_COMPLETE	0x1
#define		ACK_PENDING	0x2
#define		ACK_BUSY_X	0x4
#define		ACK_BUSY_A	0x5
#define		ACK_BUSY_B	0x6
#define		ACK_TARDY	0xB
#define		ACK_CONFLICT_ERROR	0xC
#define		ACK_DATA_ERROR	0xD
#define		ACK_TYPE_ERROR	0xE
#define		ACK_ADDRESS_ERROR	0xF

// Speed classes
#define		SPD_100		0
#define		SPD_200		1
#define		SPD_400		2

// Response codes
#define		RESP_COMPLETE	0x0
#define		RESP_CONFLICT_ERROR	0x4
#define		RESP_DATA_ERROR	0x5
#define		RESP_TYPE_ERROR	0x6
#define		RESP_ADDRESS_ERROR	0x7

// Asynchronous packet types
#define		TC_REQ_QUAD_WRITE	0x0
#define		TC_REQ_BLOCK_WRITE	0x1
#define		TC_RESP_WRITE	0x2
#define		TC_REQ_QUAD_READ	0x4
#define		TC_REQ_BLOCK_READ	0x5
#define		TC_RESP_QUAD_READ	0x6
#define		TC_RESP_BLOCK_READ 0x7
#define		TC_CYCLE_START	0x8
#define		TC_REQ_LOCK	0x9
#define		TC_ASYNC_STREAM	0xA
#define		TC_RESP_LOCK	0xB

// Extended TCodes for LOCK operations
#define		ETC_MASK_SWAP		0x0001
#define		ETC_COMPARE_SWAP	0x0002
#define		ETC_FETCH_ADD		0x0003
#define		ETC_LITTLE_ADD		0x0004
#define		ETC_BOUNDED_ADD		0x0005
#define		ETC_WRAP_ADD		0x0006

#endif
